Redmine - Defect #33896

Incorrect position of the revision graph

2020-08-24 05:04 - Go MAEDA

Status: Closed Start date:
Priority: Normal Due date:
Assignee: Go MAEDA % Done: 0%
Category: SCM Estimated time: 0.00 hour
Target version:
Resolution: Fixed Affected version:
Description
See the screenshot below. The trunk is affected, 4.1-stable is not affected.
Latest revisions
View differences
# Date Author
afcafbl6 @  07/15/2020 10:11 AM ishikawa999 I(;'I‘_'Zlga‘
8646970 © 07/15/2020 10:09 AM ishikawa999 Changg
5c6f368f 07/03/2020 04:42 PM ishikawa999 Add ta
a39b2a2f 06/11/2020 01:24 PM  ishikawa99g X the)
not chg
07510184 05/28/2020 11:26 AM ishikawa999 Fix notj
454b5cd1 05/28/2020 11:17 AM ishikawa999 Fix the|
d31b4028 05/28/2020 11:04 AM ishikawa999 Remov|
6cedce9a 05/28/2020 11:03 AM ishikawa999 Fixap
7140e97d 05/19/2020 09:16 AM ishikawa999 Fix the|
034cf727 05/19/2020 09:14 AM ishikawa999 Changg
View differences
Related issues:
Related to Redmine - Feature #33383: Update jQuery to 3.5.1 Closed

Associated revisions

Revision 20147 - 2020-10-15 16:39 - Go MAEDA

Incorrect position of the revision graph (#33896, #33383).

Patch by Marius BALTEANU.

Revision 20336 - 2020-11-12 01:15 - Go MAEDA
Fix that "View differences" buttons on RepositoriesController#diff page does not work due to r20147 (#33896, #33383).

Patch by Mizuki ISHIKAWA.

History

#1 - 2020-08-24 07:50 - Go MAEDA

The issue is likely to have been caused by r19803.

#2 - 2020-08-24 07:59 - Go MAEDA
- Related to Feature #33383: Update jQuery to 3.5.1 added

#3 - 2020-08-24 09:02 - Marius BALTEANU
https://www.redmine.org/projects/redmine/repository/svn/revisions/19803

- Assignee set to Marius BALTEANU

#4 - 2020-09-04 05:59 - Takenori TAKAKI
- File 33896.patch added

It seems to be caused by a change in jQuery that changed the value returned from position().top.
The problem seems to be fix, by replacing calculation using offset().top.

#5 - 2020-10-05 00:36 - Marius BALTEANU
- File after.png added

- File before.png added

- Assignee deleted (Marius BALTEANU)

I think the problem is related to this change: https://jquery.com/upgrade-guide/3.0/#offset.

Takenori, thanks for looking into this, I've tested your patch and it fixes the problem, but looking deeper in the code and in the DOM, | think it's better
to fix this by moving the "View differences" buttons outside the autoscroll block. Doing this, we fix another issue generated by the same cause, the
buttons are no longer visibile when you scroll to right, please see the attached screenshots.

What do you think about this fix?

diff --git a/app/views/repositories/_revisions.html.erb b/app/views/repositories/_revisions.html.erb
index 95c6898al..c7aad5fle 100644

-—— a/app/views/repositories/_revisions.html.erb

+++ b/app/views/repositories/_revisions.html.erb

@@ -1,3 +1,9 @@

+<% show_diff = revisions.size > 1 && User.current.allowed_to? (:browse_repository, @repository.project) %>
+<% if show_diff %>

+<p>

+ <%= submit_tag(l(:label_view_diff), :name => nil) %>

+</p>

+<% end %>
<div class="autoscroll">
<% show_revision_graph = ( @repository.supports_revision_graph? && path.blank? ) %>
<%= if show_revision_graph && revisions && revisions.any?
@@ -20,12 +26,6 @Q end %>
:repository_id => Q@repository.identifier_param, :path => to_path_param(path)},
:method => :get

) do %>
—<% show_diff = revisions.size > 1 && User.current.allowed_to? (:browse_repository, @repository.project) %>
—-<% if show_diff %>

—<p>
- <%= submit_tag(l(:label_view_diff), :name => nil) %>
—</p>
-<% end %>
<table class="list changesets">
<thead><tr>
<th>#</th>
@@ -53,10 +53,10 Q@ end %>
<% end %>
</tbody>
</table>
+<% end %>
+</div>
<% 1f show_diff %>
<p>
<%= submit_tag(l(:label_view_diff), :name => nil) %>
</p>
<% end %>
-<% end %>
-</div>

#6 - 2020-10-05 07:57 - Marius BALTEANU

- Target version set to 4.2.0

#7 - 2020-10-07 07:16 - Takenori TAKAKI

Thanks Marius.
| think your patch is a better improvement.
| felt it was better as a DOM structure as well.
https://jquery.com/upgrade-guide/3.0/#offset

#8 - 2020-10-15 16:39 - Go MAEDA
- Status changed from New to Closed
- Assignee set to Go MAEDA

- Target version deleted (4.2.0)

- Resolution set to Fixed

Committed the patch #33896#note-5. Thank you.

#9 - 2020-11-11 05:15 - Mizuki ISHIKAWA

- File fix-view-differences-buttons.patch added

This change resolves the visual probrem, but instead the "View differences" buttons no longer works.
The cause is that submit_tag has been moved out of the form tag.

The attached patch solves the problem by changing the position of the form tag.

#10 - 2020-11-11 06:09 - Go MAEDA

- Status changed from Closed to Reopened

#11 - 2020-11-12 01:16 - Go MAEDA
- Status changed from Reopened to Closed
Mizuki ISHIKAWA wrote:

This change resolves the visual probrem, but instead the "View differences" buttons no longer works.
The cause is that submit_tag has been moved out of the form tag.

Committed the fix in r20336. Thank you.

Files

incorrect-position-of-revision-graph.png 155 KB 2020-08-24 Go MAEDA
33896.patch 2.14 KB 2020-09-04 Takenori TAKAKI
before.png 272 KB 2020-10-04 Marius BALTEANU
after.png 292 KB 2020-10-04 Marius BALTEANU
fix-view-differences-buttons.patch 1.1 KB 2020-11-11 Mizuki ISHIKAWA
